diff --git a/doc/src/sgml/installation.sgml b/doc/src/sgml/installation.sgml
index fe8d73e1f8c..caa818a61f3 100644
--- a/doc/src/sgml/installation.sgml
+++ b/doc/src/sgml/installation.sgml
@@ -15,7 +15,7 @@
   and see <xref linkend="install-binaries" /> instead.
  </para>
 
- <sect1 id="install-requirements">
+ <sect1 id="install-requirements" xreflabel="Requirements">
   <title>Requirements</title>
 
   <para>
@@ -357,7 +357,7 @@
   </para>
  </sect1>
 
- <sect1 id="install-getsource">
+ <sect1 id="install-getsource" xreflabel="Getting the Source">
   <title>Getting the Source</title>
 
   <para>
@@ -383,10 +383,10 @@
   </para>
  </sect1>
 
- <sect1 id="install-make">
+ <sect1 id="install-make" xreflabel="Building and Installation with Autoconf and Make">
   <title>Building and Installation with Autoconf and Make</title>
 
- <sect2 id="install-short-make">
+ <sect2 id="install-short-make" xreflabel="Short Version">
   <title>Short Version</title>
 
   <para>
@@ -410,7 +410,7 @@ su - postgres
  </sect2>
 
 
- <sect2 id="install-procedure-make">
+ <sect2 id="install-procedure-make" xreflabel="Installation Procedure">
   <title>Installation Procedure</title>
 
   <procedure>
@@ -661,7 +661,7 @@ build-postgresql:
   </para>
   </sect2>
 
-  <sect2 id="configure-options">
+  <sect2 id="configure-options" xreflabel="configure Options">
    <title><filename>configure</filename> Options</title>
 
    <indexterm zone="configure-options">
@@ -676,7 +676,7 @@ build-postgresql:
     the standard Autoconf documentation.
    </para>
 
-   <sect3 id="configure-options-locations">
+   <sect3 id="configure-options-locations" xreflabel="Installation Locations">
     <title>Installation Locations</title>
 
      <para>
@@ -866,7 +866,7 @@ build-postgresql:
 
    </sect3>
 
-   <sect3 id="configure-options-features">
+   <sect3 id="configure-options-features" xreflabel="PostgreSQL Features">
     <title><productname>PostgreSQL</productname> Features</title>
 
     <para>
@@ -1251,7 +1251,7 @@ build-postgresql:
 
    </sect3>
 
-   <sect3 id="configure-options-anti-features">
+   <sect3 id="configure-options-anti-features" xreflabel="Anti-Features">
     <title>Anti-Features</title>
 
     <para>
@@ -1319,7 +1319,7 @@ build-postgresql:
 
    </sect3>
 
-   <sect3 id="configure-options-build-process">
+   <sect3 id="configure-options-build-process" xreflabel="Build Process Details">
     <title>Build Process Details</title>
 
      <variablelist>
@@ -1433,7 +1433,7 @@ build-postgresql:
 
    </sect3>
 
-   <sect3 id="configure-options-misc">
+   <sect3 id="configure-options-misc" xreflabel="Miscellaneous">
     <title>Miscellaneous</title>
 
     <para>
@@ -1535,7 +1535,7 @@ build-postgresql:
 
    </sect3>
 
-   <sect3 id="configure-options-devel">
+   <sect3 id="configure-options-devel" xreflabel="Developer Options">
     <title>Developer Options</title>
 
     <para>
@@ -1715,7 +1715,7 @@ build-postgresql:
 
   </sect2>
 
-  <sect2 id="configure-envvars">
+  <sect2 id="configure-envvars" xreflabel="configure Environment Variables">
    <title><filename>configure</filename> Environment Variables</title>
 
    <indexterm zone="configure-envvars">
@@ -1999,10 +1999,10 @@ build-postgresql:
   </sect2>
  </sect1>
 
- <sect1 id="install-meson">
+ <sect1 id="install-meson" xreflabel="Building and Installation with Meson">
   <title>Building and Installation with Meson</title>
 
- <sect2 id="install-short-meson">
+ <sect2 id="install-short-meson" xreflabel="Short Version">
   <title>Short Version</title>
 
   <para>
@@ -2026,7 +2026,7 @@ su - postgres
   </para>
  </sect2>
 
- <sect2 id="install-procedure-meson">
+ <sect2 id="install-procedure-meson" xreflabel="Installation Procedure">
   <title>Installation Procedure</title>
 
   <procedure>
@@ -2204,7 +2204,7 @@ ninja install
   </formalpara>
   </sect2>
 
-  <sect2 id="meson-options">
+  <sect2 id="meson-options" xreflabel="meson setup Options">
    <title><literal>meson setup</literal> Options</title>
 
    <para>
@@ -2217,7 +2217,7 @@ ninja install
     setup</command> as well.
    </para>
 
-   <sect3 id="meson-options-locations">
+   <sect3 id="meson-options-locations" xreflabel="Installation Locations">
     <title>Installation Locations</title>
 
      <para>
@@ -2356,7 +2356,7 @@ ninja install
      </note>
     </sect3>
 
-   <sect3 id="meson-options-features">
+   <sect3 id="meson-options-features" xreflabel="PostgreSQL Features">
     <title><productname>PostgreSQL</productname> Features</title>
 
     <para>
@@ -2712,7 +2712,7 @@ ninja install
     </variablelist>
    </sect3>
 
-   <sect3 id="meson-options-anti-features">
+   <sect3 id="meson-options-anti-features" xreflabel="Anti-Features">
     <title>Anti-Features</title>
 
     <variablelist>
@@ -2759,7 +2759,7 @@ ninja install
     </variablelist>
    </sect3>
 
-   <sect3 id="meson-options-build-process">
+   <sect3 id="meson-options-build-process" xreflabel="Build Process Details">
     <title>Build Process Details</title>
 
     <variablelist>
@@ -2929,7 +2929,7 @@ ninja install
     </variablelist>
    </sect3>
 
-   <sect3 id="meson-options-docs">
+   <sect3 id="meson-options-docs" xreflabel="Documentation">
     <title>Documentation</title>
 
     <para>
@@ -2974,7 +2974,7 @@ ninja install
     </variablelist>
    </sect3>
 
-   <sect3 id="meson-options-misc">
+   <sect3 id="meson-options-misc" xreflabel="Miscellaneous">
     <title>Miscellaneous</title>
 
     <variablelist>
@@ -3057,7 +3057,7 @@ ninja install
     </variablelist>
    </sect3>
 
-   <sect3 id="meson-options-devel">
+   <sect3 id="meson-options-devel" xreflabel="Developer Options">
     <title>Developer Options</title>
 
     <para>
@@ -3248,7 +3248,7 @@ ninja install
    </sect3>
   </sect2>
 
-  <sect2 id="targets-meson">
+  <sect2 id="targets-meson" xreflabel="meson Build Targets">
    <title><literal>meson</literal> Build Targets</title>
 
    <para>
@@ -3264,10 +3264,10 @@ ninja install
 
  </sect1>
 
- <sect1 id="install-post">
+ <sect1 id="install-post" xreflabel="Post-Installation Setup">
   <title>Post-Installation Setup</title>
 
-  <sect2 id="install-post-shlibs">
+  <sect2 id="install-post-shlibs" xreflabel="Shared Libraries">
    <title>Shared Libraries</title>
 
    <indexterm>
@@ -3355,7 +3355,7 @@ libpq.so.2.1: cannot open shared object file: No such file or directory
    </para>
   </sect2>
 
-  <sect2 id="install-post-env-vars">
+  <sect2 id="install-post-env-vars" xreflabel="Environment Variables">
    <title>Environment Variables</title>
 
    <indexterm>
@@ -3412,7 +3412,7 @@ export MANPATH
   </sect2>
  </sect1>
 
- <sect1 id="supported-platforms">
+ <sect1 id="supported-platforms" xreflabel="Supported Platforms">
   <title>Supported Platforms</title>
 
   <para>
@@ -3467,7 +3467,7 @@ export MANPATH
   </para>
  </sect1>
 
- <sect1 id="installation-platform-notes">
+ <sect1 id="installation-platform-notes" xreflabel="Platform-Specific Notes">
   <title>Platform-Specific Notes</title>
 
   <para>
@@ -3484,7 +3484,7 @@ export MANPATH
    installation issues.
   </para>
 
-  <sect2 id="installation-notes-cygwin">
+  <sect2 id="installation-notes-cygwin" xreflabel="Cygwin">
    <title>Cygwin</title>
 
    <indexterm zone="installation-notes-cygwin">
@@ -3585,7 +3585,7 @@ make MAX_CONNECTIONS=5 check
    </para>
   </sect2>
 
-  <sect2 id="installation-notes-macos">
+  <sect2 id="installation-notes-macos" xreflabel="macOS">
    <title>macOS</title>
 
    <indexterm zone="installation-notes-macos">
@@ -3660,7 +3660,7 @@ xcrun --show-sdk-path
    </para>
   </sect2>
 
-  <sect2 id="installation-notes-mingw">
+  <sect2 id="installation-notes-mingw" xreflabel="MinGW">
    <title>MinGW</title>
 
    <indexterm zone="installation-notes-mingw">
@@ -3675,7 +3675,7 @@ xcrun --show-sdk-path
     to install any prerequisite packages.
    </para>
 
-   <sect3 id="mingw-crash-dumps">
+   <sect3 id="mingw-crash-dumps" xreflabel="Collecting Crash Dumps">
     <title>Collecting Crash Dumps</title>
 
     <para>
@@ -3692,7 +3692,7 @@ xcrun --show-sdk-path
    </sect3>
   </sect2>
 
-  <sect2 id="installation-notes-solaris">
+  <sect2 id="installation-notes-solaris" xreflabel="Solaris">
    <title>Solaris</title>
 
    <indexterm zone="installation-notes-solaris">
@@ -3705,7 +3705,7 @@ xcrun --show-sdk-path
     operating system, the fewer issues you will experience.
    </para>
 
-   <sect3 id="installation-notes-solaris-req-tools">
+   <sect3 id="installation-notes-solaris-req-tools" xreflabel="Required Tools">
     <title>Required Tools</title>
 
     <para>
@@ -3719,7 +3719,7 @@ xcrun --show-sdk-path
     </para>
    </sect3>
 
-   <sect3 id="installation-notes-solaris-configure-complains">
+   <sect3 id="installation-notes-solaris-configure-complains" xreflabel="configure Complains About a Failed Test Program">
     <title>configure Complains About a Failed Test Program</title>
 
     <para>
@@ -3738,7 +3738,7 @@ configure ... LDFLAGS="-R /usr/sfw/lib:/opt/sfw/lib:/usr/local/lib"
     </para>
    </sect3>
 
-   <sect3 id="installation-notes-solaris-using-dtrace">
+   <sect3 id="installation-notes-solaris-using-dtrace" xreflabel="Using DTrace for Tracing PostgreSQL">
     <title>Using DTrace for Tracing PostgreSQL</title>
 
     <para>
@@ -3748,7 +3748,7 @@ configure ... LDFLAGS="-R /usr/sfw/lib:/opt/sfw/lib:/usr/local/lib"
    </sect3>
   </sect2>
 
-  <sect2 id="installation-notes-visual-studio">
+  <sect2 id="installation-notes-visual-studio" xreflabel="Visual Studio">
    <title>Visual Studio</title>
 
    <indexterm zone="installation-notes-visual-studio">
@@ -3825,7 +3825,7 @@ configure ... LDFLAGS="-R /usr/sfw/lib:/opt/sfw/lib:/usr/local/lib"
     complete command-line build environment.
    </para>
 
-   <sect3 id="windows-requirements">
+   <sect3 id="windows-requirements" xreflabel="Requirements">
     <title>Requirements</title>
     <para>
      The following additional products are required to build
@@ -3985,7 +3985,7 @@ configure ... LDFLAGS="-R /usr/sfw/lib:/opt/sfw/lib:/usr/local/lib"
     </para>
    </sect3>
 
-   <sect3 id="windows-crash-dumps">
+   <sect3 id="windows-crash-dumps" xreflabel="Collecting Crash Dumps">
     <title>Collecting Crash Dumps</title>
 
     <para>
diff --git a/doc/src/sgml/intagg.sgml b/doc/src/sgml/intagg.sgml
index 29e74ce146c..f7d2076a079 100644
--- a/doc/src/sgml/intagg.sgml
+++ b/doc/src/sgml/intagg.sgml
@@ -15,7 +15,7 @@
   the built-in functions.
  </para>
 
- <sect2 id="intagg-functions">
+ <sect2 id="intagg-functions" xreflabel="Functions">
   <title>Functions</title>
 
  <indexterm>
@@ -50,7 +50,7 @@
 
  </sect2>
 
- <sect2 id="intagg-samples">
+ <sect2 id="intagg-samples" xreflabel="Sample Uses">
   <title>Sample Uses</title>
 
   <para>
diff --git a/doc/src/sgml/intarray.sgml b/doc/src/sgml/intarray.sgml
index c72d49b01d8..26c812a5b79 100644
--- a/doc/src/sgml/intarray.sgml
+++ b/doc/src/sgml/intarray.sgml
@@ -30,7 +30,7 @@
   on the current database.
  </para>
 
- <sect2 id="intarray-funcs-ops">
+ <sect2 id="intarray-funcs-ops" xreflabel="intarray Functions and Operators">
   <title><filename>intarray</filename> Functions and Operators</title>
 
   <para>
@@ -391,7 +391,7 @@
   </para>
  </sect2>
 
- <sect2 id="intarray-index">
+ <sect2 id="intarray-index" xreflabel="Index Support">
   <title>Index Support</title>
 
   <para>
@@ -443,7 +443,7 @@
   </para>
  </sect2>
 
- <sect2 id="intarray-example">
+ <sect2 id="intarray-example" xreflabel="Example">
   <title>Example</title>
 
 <programlisting>
@@ -464,7 +464,7 @@ SELECT message.mid FROM message WHERE message.sections @@ '1&amp;2'::query_int;
 </programlisting>
  </sect2>
 
- <sect2 id="intarray-benchmark">
+ <sect2 id="intarray-benchmark" xreflabel="Benchmark">
   <title>Benchmark</title>
 
   <para>
@@ -488,7 +488,7 @@ psql -c "CREATE EXTENSION intarray" TEST
   </para>
  </sect2>
 
- <sect2 id="intarray-Authors">
+ <sect2 id="intarray-Authors" xreflabel="Authors">
   <title>Authors</title>
 
   <para>
diff --git a/doc/src/sgml/intro.sgml b/doc/src/sgml/intro.sgml
index fec72481b54..cf6340c0643 100644
--- a/doc/src/sgml/intro.sgml
+++ b/doc/src/sgml/intro.sgml
@@ -81,7 +81,7 @@
   </itemizedlist>
  </para>
 
- <sect1 id="intro-whatis">
+ <sect1 id="intro-whatis" xreflabel=" What Is PostgreSQL?">
   <title> What Is <productname>PostgreSQL</productname>?</title>
 
   <para>
diff --git a/doc/src/sgml/isn.sgml b/doc/src/sgml/isn.sgml
index d0ab06ca8d0..37dae676f54 100644
--- a/doc/src/sgml/isn.sgml
+++ b/doc/src/sgml/isn.sgml
@@ -27,7 +27,7 @@
   on the current database.
  </para>
 
- <sect2 id="isn-data-types">
+ <sect2 id="isn-data-types" xreflabel="Data Types">
   <title>Data Types</title>
 
   <para>
@@ -156,7 +156,7 @@
   </para>
  </sect2>
 
- <sect2 id="isn-casts">
+ <sect2 id="isn-casts" xreflabel="Casts">
   <title>Casts</title>
 
   <para>
@@ -224,7 +224,7 @@
   </para>
  </sect2>
 
- <sect2 id="isn-funcs-ops">
+ <sect2 id="isn-funcs-ops" xreflabel="Functions and Operators">
   <title>Functions and Operators</title>
 
   <para>
@@ -303,7 +303,7 @@
   </table>
  </sect2>
 
- <sect2 id="isn-configuration-parameters">
+ <sect2 id="isn-configuration-parameters" xreflabel="Configuration Parameters">
   <title>Configuration Parameters</title>
 
   <variablelist>
@@ -360,7 +360,7 @@
   </para>
  </sect2>
 
- <sect2 id="isn-examples">
+ <sect2 id="isn-examples" xreflabel="Examples">
   <title>Examples</title>
 
 <programlisting>
@@ -404,7 +404,7 @@ SELECT isbn13(id) FROM test;
 </programlisting>
  </sect2>
 
- <sect2 id="isn-bibliography">
+ <sect2 id="isn-bibliography" xreflabel="Bibliography">
   <title>Bibliography</title>
 
   <para>
@@ -432,7 +432,7 @@ SELECT isbn13(id) FROM test;
   </para>
  </sect2>
 
- <sect2 id="isn-author">
+ <sect2 id="isn-author" xreflabel="Author">
   <title>Author</title>
   <para>
    Germ&aacute;n M&eacute;ndez Bravo (Kronuz), 2004&ndash;2006
diff --git a/doc/src/sgml/jit.sgml b/doc/src/sgml/jit.sgml
index 44e18bf1a6f..9a10c3bc5e4 100644
--- a/doc/src/sgml/jit.sgml
+++ b/doc/src/sgml/jit.sgml
@@ -17,7 +17,7 @@
   configured in <productname>PostgreSQL</productname>.
  </para>
 
- <sect1 id="jit-reason">
+ <sect1 id="jit-reason" xreflabel="What Is JIT compilation?">
   <title>What Is <acronym>JIT</acronym> compilation?</title>
 
   <para>
@@ -43,7 +43,7 @@
    See <filename>src/backend/jit/README</filename> for further details.
   </para>
 
-  <sect2 id="jit-accelerated-operations">
+  <sect2 id="jit-accelerated-operations" xreflabel="JIT Accelerated Operations">
    <title><acronym>JIT</acronym> Accelerated Operations</title>
    <para>
     Currently <productname>PostgreSQL</productname>'s <acronym>JIT</acronym>
@@ -64,7 +64,7 @@
    </para>
   </sect2>
 
-  <sect2 id="jit-inlining">
+  <sect2 id="jit-inlining" xreflabel="Inlining">
    <title>Inlining</title>
    <para>
     <productname>PostgreSQL</productname> is very extensible and allows new
@@ -78,7 +78,7 @@
    </para>
   </sect2>
 
-  <sect2 id="jit-optimization">
+  <sect2 id="jit-optimization" xreflabel="Optimization">
    <title>Optimization</title>
    <para>
     <productname>LLVM</productname> has support for optimizing generated
@@ -92,7 +92,7 @@
 
  </sect1>
 
- <sect1 id="jit-decision">
+ <sect1 id="jit-decision" xreflabel="When to JIT?">
   <title>When to <acronym>JIT</acronym>?</title>
 
   <para>
@@ -212,10 +212,10 @@ SET
   </para>
  </sect1>
 
- <sect1 id="jit-extensibility">
+ <sect1 id="jit-extensibility" xreflabel="Extensibility">
   <title>Extensibility</title>
 
-  <sect2 id="jit-extensibility-bitcode">
+  <sect2 id="jit-extensibility-bitcode" xreflabel="Inlining Support for Extensions">
    <title>Inlining Support for Extensions</title>
    <para>
     <productname>PostgreSQL</productname>'s <acronym>JIT</acronym>
@@ -246,7 +246,7 @@ SET
    </para>
   </sect2>
 
-  <sect2 id="jit-pluggable">
+  <sect2 id="jit-pluggable" xreflabel="Pluggable JIT Providers">
    <title>Pluggable <acronym>JIT</acronym> Providers</title>
 
    <para>
@@ -259,7 +259,7 @@ SET
     <xref linkend="guc-jit-provider"/>.
    </para>
 
-   <sect3 id="jit-pluggable-provider-interface">
+   <sect3 id="jit-pluggable-provider-interface" xreflabel="JIT Provider Interface">
     <title><acronym>JIT</acronym> Provider Interface</title>
     <para>
      A <acronym>JIT</acronym> provider is loaded by dynamically loading the
diff --git a/doc/src/sgml/json.sgml b/doc/src/sgml/json.sgml
index 206eadb8f7b..837579a87e0 100644
--- a/doc/src/sgml/json.sgml
+++ b/doc/src/sgml/json.sgml
@@ -1,6 +1,6 @@
 <!-- doc/src/sgml/json.sgml -->
 
-<sect1 id="datatype-json">
+<sect1 id="datatype-json" xreflabel="JSON Types">
  <title><acronym>JSON</acronym> Types</title>
 
  <indexterm zone="datatype-json">
@@ -168,7 +168,7 @@
      </tgroup>
    </table>
 
- <sect2 id="json-keys-elements">
+ <sect2 id="json-keys-elements" xreflabel="JSON Input and Output Syntax">
   <title>JSON Input and Output Syntax</title>
   <para>
    The input/output syntax for the JSON data types is as specified in
@@ -234,7 +234,7 @@ SELECT '{"reading": 1.230e-5}'::json, '{"reading": 1.230e-5}'::jsonb;
   </para>
  </sect2>
 
- <sect2 id="json-doc-design">
+ <sect2 id="json-doc-design" xreflabel="Designing JSON Documents">
   <title>Designing JSON Documents</title>
   <para>
    Representing data as JSON can be considerably more flexible than
@@ -263,7 +263,7 @@ SELECT '{"reading": 1.230e-5}'::json, '{"reading": 1.230e-5}'::jsonb;
   </para>
  </sect2>
 
- <sect2 id="json-containment">
+ <sect2 id="json-containment" xreflabel="jsonb Containment and Existence">
   <title><type>jsonb</type> Containment and Existence</title>
   <indexterm>
     <primary>jsonb</primary>
@@ -399,7 +399,7 @@ SELECT doc-&gt;'site_name' FROM websites
   </para>
  </sect2>
 
- <sect2 id="json-indexing">
+ <sect2 id="json-indexing" xreflabel="jsonb Indexing">
   <title><type>jsonb</type> Indexing</title>
   <indexterm>
     <primary>jsonb</primary>
@@ -613,7 +613,7 @@ SELECT jdoc->'guid', jdoc->'name' FROM api WHERE jdoc @@ '$.tags[*] == "qui"';
   </para>
  </sect2>
 
- <sect2 id="jsonb-subscripting">
+ <sect2 id="jsonb-subscripting" xreflabel="jsonb Subscripting">
   <title><type>jsonb</type> Subscripting</title>
   <para>
    The <type>jsonb</type> data type supports array-style subscripting expressions
@@ -712,7 +712,7 @@ UPDATE table_name SET jsonb_field[1]['a'] = '1';
   </para>
  </sect2>
 
- <sect2 id="datatype-json-transforms">
+ <sect2 id="datatype-json-transforms" xreflabel="Transforms">
   <title>Transforms</title>
 
   <para>
@@ -740,7 +740,7 @@ UPDATE table_name SET jsonb_field[1]['a'] = '1';
   </para>
  </sect2>
 
- <sect2 id="datatype-jsonpath">
+ <sect2 id="datatype-jsonpath" xreflabel="jsonpath Type">
   <title>jsonpath Type</title>
 
   <indexterm zone="datatype-jsonpath">
